Structure condition
    Dim Length As Long
    Dim Command As Long
    Dim Bytes() As Byte
End Structure


Structure action
    Dim Length As Long
    Dim Command As Long
    Dim Bytes() As Byte
End Structure
Structure Record
    Dim If_Else As Byte
    Dim Conditioncount As Long
    Dim Conditions() As condition
    Dim Actioncount As Long
    Dim Actions() As action
    Dim Recordname As String
    Dim RecordNameBytes() As Byte
End Structure

Structure Block
    Dim BlockName As String
    Dim BlockNameBytes() As Byte
    Dim RecordCount As Long
    Dim Records() As Record
End Structure


Public Class Form1
    Dim Blocks(50) As Block
    Dim ThisRecord As Record
    Dim File_Version As Long
    Dim BlockCount As Long
    Dim QSDName As String
    Dim QSDNameBytes(500) As Byte
    Dim NameLen As Integer
    Dim readpos As Long

    Dim dp As Byte
    Dim BlockIndex As Long
    Dim RecordIndex As Long
    Dim ActionIndex As Long
    Dim CondIndex As Long
    Dim RefVar As String
    Public OpMode As Integer
    Dim TBL(500) As Byte
    Dim ThisCondOpCode As Integer
    Dim ThisActionOpCode As Integer
    Dim CondFormat(10) As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Load a QSD file
        Dim a As Integer
        Dim n As Integer
        Dim i As Long
        Dim j As Long
        Dim k As Long
        Dim l As Long
        Dim filepath As String

        'clear listbox1
        ListBox1.Items.Clear()


        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Title = "Import QSD file."
        OpenFileDialog1.Filter = "ROSE QSD Files (*.QSD)|*.QSD"
        OpenFileDialog1.ShowDialog()
        filepath = OpenFileDialog1.FileName

        If filepath = "" Then Exit Sub 'detect cancel
        TextBox1.Text = filepath

        Dim fs As System.IO.FileStream
        Dim r As System.IO.BinaryReader
        Dim mylength As Long
        fs = New System.IO.FileStream(filepath, IO.FileMode.OpenOrCreate)
        r = New System.IO.BinaryReader(fs)
        mylength = fs.Length

        File_Version = r.ReadUInt32
        BlockCount = r.ReadUInt32
        NameLen = r.ReadUInt16
        a = a
        QSDName = ""
        For n = 1 To NameLen
            dp = r.ReadByte
            QSDNameBytes(n) = dp
            a = a
            QSDName += Chr(dp)
        Next n
        

        a = a
        
        'readpos = NameLen + 11

        For i = 1 To BlockCount
            Blocks(i).BlockNameBytes = New Byte(20) {}
            Blocks(i).Records = New Record(50) {}
            Blocks(i).RecordCount = r.ReadUInt32
            'readpos = readpos + 4
            NameLen = r.ReadUInt16
            'readpos = readpos + 2
            Blocks(i).BlockName = ""
            For n = 1 To NameLen
                dp = r.ReadByte
                'Blocks(i).BlockNameBytes = New Byte()
                Blocks(i).BlockNameBytes(n) = dp
                Blocks(i).BlockName += Chr(Blocks(i).BlockNameBytes(n))
            Next n
            'readpos = readpos + NameLen
            ListBox1.Items.Add("Block: " + CStr(i))


            For j = 1 To Blocks(i).RecordCount
                Blocks(i).Records(j).RecordNameBytes = New Byte(40) {}
                Blocks(i).Records(j).If_Else = r.ReadByte
                Blocks(i).Records(j).Conditions = New condition(50) {}
                Blocks(i).Records(j).Actions = New action(50) {}
                'If false, all conditions must be met, if true, one condition
                'readpos = readpos + 1
                Blocks(i).Records(j).Conditioncount = r.ReadUInt32
                'readpos = readpos + 4
                Blocks(i).Records(j).Actioncount = r.ReadUInt32
                'readpos = readpos + 4
                NameLen = r.ReadUInt16
                'readpos = readpos + 2
                For n = 1 To NameLen
                    dp = r.ReadByte
                    Blocks(i).Records(j).RecordNameBytes(n) = dp
                    If n < NameLen Then
                        Blocks(i).Records(j).Recordname += Chr(dp)
                    End If
                Next n
                'a = a
                For k = 1 To Blocks(i).Records(j).Conditioncount
                    Blocks(i).Records(j).Conditions(k).Bytes = New Byte(200) {}
                    Blocks(i).Records(j).Conditions(k).Length = r.ReadUInt32
                    'readpos = readpos + 4
                    Blocks(i).Records(j).Conditions(k).Command = r.ReadUInt32
                    'readpos = readpos + 4
                    For l = 1 To Blocks(i).Records(j).Conditions(k).Length - 8
                        Blocks(i).Records(j).Conditions(k).Bytes(l) = r.ReadByte
                        'readpos = readpos + 1
                    Next l
                Next k
                For k = 1 To Blocks(i).Records(j).Actioncount
                    Blocks(i).Records(j).Actions(k).Bytes = New Byte(200) {}
                    Blocks(i).Records(j).Actions(k).Length = r.ReadUInt32
                    'readpos = readpos + 4
                    Blocks(i).Records(j).Actions(k).Command = r.ReadUInt32
                    'readpos = readpos + 4
                    For l = 1 To Blocks(i).Records(j).Actions(k).Length - 8
                        Blocks(i).Records(j).Actions(k).Bytes(l) = r.ReadByte
                        'readpos = readpos + 1
                    Next l
                Next k
            Next j
        Next i
        r.Close()
        fs.Close()
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim a, n, i, j, k, l, Writepos As Integer
        Dim filepath, msg, testname As String
        Dim TempByte, BlankByte As Byte

        BlankByte = 0
        'first make sure all the blocks have names
        For i = 1 To BlockCount
            For j = 1 To Blocks(i).RecordCount
                If Len(Blocks(i).Records(j).Recordname) = 0 Then
                    msg = "Block " + CStr(i) + " Record " + CStr(j) + " has no name. Please name it before saving the QSD"
                    MsgBox(msg)
                    Exit Sub
                End If
                'now check each name to make sure we didn't duplicate one
                testname = Blocks(i).Records(j).Recordname
                For k = 1 To BlockCount
                    For l = 1 To Blocks(k).RecordCount
                        If k <> i And l <> j Then
                            If Blocks(k).Records(l).Recordname = testname Then
                                msg = "Block " + CStr(k) + " Record " + CStr(l) + " is using the same name as Block " + CStr(i) + " Record " + CStr(j) + " Please rchange one of them before saving the QSD"
                                MsgBox(msg)
                                Exit Sub
                            End If
                        End If
                    Next
                Next
            Next
        Next

        SaveFileDialog1.FileName = ""
        SaveFileDialog1.Title = "Import QSD file."
        SaveFileDialog1.Filter = "ROSE QSD Files (*.QSD)|*.QSD"
        SaveFileDialog1.ShowDialog()
        filepath = SaveFileDialog1.FileName

        If filepath = "" Then Exit Sub 'detect cancel
        TextBox1.Text = filepath

        Dim fs As System.IO.FileStream
        Dim r As System.IO.BinaryWriter
        Dim mylength As Long
        fs = New System.IO.FileStream(filepath, IO.FileMode.Create)
        r = New System.IO.BinaryWriter(fs)
        mylength = fs.Length


        r.Write(File_Version)
        fs.Position = 4
        r.Write(BlockCount)
        fs.Position = 8
        NameLen = Len(QSDName)
        r.Write(NameLen)
        Writepos = 10
        For n = 0 To NameLen - 1
            fs.Position = Writepos
            Writepos = Writepos + 1
            r.Write(QSDNameBytes(n))
        Next
        a = a

        'Writepos = NameLen + 11

        For i = 1 To BlockCount
            fs.Position = Writepos
            r.Write(Blocks(i).RecordCount)
            'Blocks(i).RecordCount = r.ReadUInt32
            Writepos = Writepos + 4
            fs.Position = Writepos
            NameLen = Len(Blocks(i).BlockName)
            r.Write(NameLen)
            'NameLen = r.ReadUInt16
            Writepos = Writepos + 2
            fs.Position = Writepos
            'Blocks(i).BlockName = ""
            For n = 1 To NameLen
                r.Write(Blocks(i).BlockNameBytes(n))
                'dp = r.ReadByte
                Writepos = Writepos + 1
                fs.Position = Writepos
            Next n

            For j = 1 To Blocks(i).RecordCount
                r.Write(Blocks(i).Records(j).If_Else)
                'Blocks(i).Records(j).If_Else = r.ReadByte
                Writepos = Writepos + 1
                fs.Position = Writepos
                r.Write(Blocks(i).Records(j).Conditioncount)
                'Blocks(i).Records(j).Conditioncount = r.ReadUInt32
                Writepos = Writepos + 4
                fs.Position = Writepos
                r.Write(Blocks(i).Records(j).Actioncount)
                'Blocks(i).Records(j).Actioncount = r.ReadUInt32
                Writepos = Writepos + 4
                fs.Position = Writepos
                NameLen = Len(Blocks(i).Records(j).Recordname)
                r.Write(NameLen + 1)
                'NameLen = r.ReadUInt16
                Writepos = Writepos + 2
                fs.Position = Writepos
                For n = 1 To NameLen
                    tempbyte = CByte(Asc(Mid(Blocks(i).Records(j).Recordname, n, 1)))
                    r.Write(tempbyte)
                    'dp = r.ReadByte
                    Writepos = Writepos + 1
                    fs.Position = Writepos
                Next n
                r.Write(BlankByte)
                Writepos = Writepos + 1
                'a = a
                For k = 1 To Blocks(i).Records(j).Conditioncount
                    r.Write(Blocks(i).Records(j).Conditions(k).Length)
                    'Blocks(i).Records(j).Conditions(k).Length = r.ReadUInt32
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    r.Write(Blocks(i).Records(j).Conditions(k).Command)
                    'Blocks(i).Records(j).Conditions(k).Command = r.ReadUInt32
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    For l = 1 To Blocks(i).Records(j).Conditions(k).Length - 8
                        r.Write(Blocks(i).Records(j).Conditions(k).Bytes(l))
                        'Blocks(i).Records(j).Conditions(k).Bytes(l) = r.ReadByte
                        Writepos = Writepos + 1
                        fs.Position = Writepos
                    Next l
                Next k
                For k = 1 To Blocks(i).Records(j).Actioncount
                    r.Write(Blocks(i).Records(j).Actions(k).Length)
                    'Blocks(i).Records(j).Actions(k).Length = r.ReadUInt32
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    r.Write(Blocks(i).Records(j).Actions(k).Command)
                    'Blocks(i).Records(j).Actions(k).Command = r.ReadUInt32
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    For l = 1 To Blocks(i).Records(j).Actions(k).Length - 8
                        r.Write(Blocks(i).Records(j).Actions(k).Bytes(l))
                        'Blocks(i).Records(j).Actions(k).Bytes(l) = r.ReadByte
                        Writepos = Writepos + 1
                        fs.Position = Writepos
                    Next l
                Next k
            Next j
        Next i
        r.Close()
        fs.Close()
        MsgBox("record saved")
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Dim i As Integer
        'BlockIndex = ListBox1.ListIndex + 1
        BlockIndex = ListBox1.SelectedIndex + 1
        ListBox2.Items.Clear()
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        'ClearCondBytes()
        'ClearActionBytes()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        TextBox10.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub

    Private Sub ListBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox2.SelectedIndexChanged
        Dim i As Integer
        Dim OpCode As Long
        RecordIndex = ListBox2.SelectedIndex + 1
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        'ClearCondBytes()
        'ClearActionBytes()
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        RefVar = "undefined"

        ThisRecord = Blocks(BlockIndex).Records(RecordIndex)

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            ListBox4.Items.Add(GetCond(OpCode, i, 0))
        Next i

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ListBox6.Items.Add(GetAction(OpCode, i, 0))
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
        If Blocks(BlockIndex).Records(RecordIndex).If_Else = 1 Then
            CheckBox1.Checked = True
        Else
            CheckBox1.Checked = False
        End If
    End Sub
    Function GetCond(ByVal OpCode As Long, ByVal i As Integer, ByVal mode As Integer) As String
        Dim t As Integer
        Dim BL(200) As Byte
        Dim ThisSplit(200) As String
        Dim qid, DataCnt, iType, iVarNo, iVarType, iValue, btOp, arraysize As Long
        Dim cond, btrev, TempByteString As String
        Dim ThisType, ThisItem, Slot, IsLeader, iLevel, btreversed, Zone, radius, ulTime, ulEndTime As Long
        Dim ThisX, ThisY, ThisZ As Decimal
        Dim Skill1, Skill2, Highpoint, lowPoint, btWho, nVarno, EventId, FlagId, TrueFalse As Long
        Dim nNumber1, nNumber2, ThisDate, hour1, hour2, min1, min2, btreg, npos, ngrd, nPoint As Long

        If mode = 0 Then
            ListBox3.Items.Add(OpCode)
            For t = 1 To 200 'copy the data into a more managable format
                BL(t) = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Bytes(t)
            Next t
        Else
            TempByteString = TextBox6.Text
            ThisSplit = Split(TempByteString, "  ", -1)
            arraysize = ThisSplit.GetUpperBound(0)
            If arraysize > 0 Then
                For t = 0 To arraysize 'copy the data into a more managable format
                    BL(t) = CByte(ThisSplit(t))
                Next t
            End If
        End If

            GetCond = "No definition available for opcode " + CStr(OpCode)
            Select Case OpCode
                Case 0
                    qid = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    GetCond = "Check player's quest list for quest " + CStr(qid) + " TRUE if it is present"
                Case 1
                    DataCnt = FindVal(BL(2), BL(1), 0, 0, 2)
                    iType = FindVal(BL(4), BL(3), 0, 0, 2)
                    iVarNo = FindVal(BL(6), BL(5), 0, 0, 2)
                    iVarType = FindVal(BL(8), BL(7), 0, 0, 2)
                    iValue = FindVal(BL(10), BL(9), 0, 0, 2)
                    btOp = FindVal(BL(11), 0, 0, 0, 1)

                    GetCond = "Check Quest variable"
                Case 2
                    GetCond = "Check Quest variable"
                Case 3
                    DataCnt = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    ThisType = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                    iValue = FindVal(BL(12), BL(11), BL(10), BL(9), 4)
                    btOp = FindVal(BL(13), 0, 0, 0, 1)
                    cond = GetbtOp(btOp)
                    GetCond = "Check Stats." + GetSoption(ThisType) + cond + CStr(iValue)
                Case 4
                    DataCnt = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    ThisItem = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                    Slot = FindVal(BL(12), BL(11), BL(10), BL(9), 4)
                    iValue = FindVal(BL(16), BL(15), BL(14), BL(13), 4)
                    btOp = FindVal(BL(17), 0, 0, 0, 1)
                    GetCond = "DataCount: " + CStr(DataCnt) + " Search inventory for type: " + CStr(Slot) + " item id: " + CStr(ThisItem) + " requested " + GetbtOp(btOp) + " " + CStr(iValue)
                Case 5
                    IsLeader = FindVal(BL(1), 0, 0, 0, 1)
                    iLevel = FindVal(BL(4), BL(3), 0, 0, 2)
                    btreversed = FindVal(BL(5), 0, 0, 0, 1)
                    If btreversed = 1 Then btrev = "IS NOT" Else btrev = "IS"
                    GetCond = "Check party. TRUE if player " + btrev + " the party leader and teh party level is at least " + CStr(iLevel)
                Case 6
                    Zone = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    ThisX = FindVal(BL(8), BL(7), BL(6), BL(5), 4) / 100
                    ThisY = FindVal(BL(12), BL(11), BL(10), BL(9), 4) / 100
                    ThisZ = FindVal(BL(16), BL(15), BL(14), BL(13), 4) / 100
                    radius = FindVal(BL(20), BL(19), BL(18), BL(17), 4)
                    GetCond = "Am I within Radius: " + CStr(radius) + " of point. Map: " + CStr(Zone) + " X: " + CStr(ThisX) + " Y: " + CStr(ThisY)
                Case 7
                    ulTime = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    ulEndTime = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                    GetCond = "Check World Time... Not coded"
                Case 8
                    ulTime = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                    btOp = FindVal(BL(5), 0, 0, 0, 1)
                    GetCond = "Check timed quest. TRUE if elapsed time " + GetbtOp(btOp) + " " + CStr(ulTime)
                Case 9
                    Skill1 = FindVal(BL(2), BL(1), 0, 0, 2)
                    Skill2 = FindVal(BL(4), BL(3), 0, 0, 2)
                    btOp = FindVal(BL(5), 0, 0, 0, 1)
                    cond = "Error undefined btop " + CStr(btOp)
                    If btOp = 0 Then cond = "has them"
                    If btOp = 10 Then cond = "doesn't have them"
                    GetCond = "Check skills " + CStr(Skill1) + " and " + CStr(Skill2) + ". True if player " + cond
                Case 10
                    lowPoint = FindVal(BL(1), 0, 0, 0, 1)
                    Highpoint = FindVal(BL(2), 0, 0, 0, 1)
                GetCond = "TRUE if random value is between " + CStr(lowPoint) + " and " + CStr(Highpoint)
                Case 11
                    btWho = FindVal(BL(1), 0, 0, 0, 1)
                    nVarno = FindVal(BL(4), BL(3), 0, 0, 2)
                    iValue = FindVal(BL(6), BL(5), 0, 0, 2)
                    btOp = FindVal(BL(7), 0, 0, 0, 1)
                    If btWho = 0 Then
                        GetCond = "Check ObjVar[" + RefVar + "][" + CStr(nVarno) + ". TRUE if current value " + GetbtOp(btOp) + CStr(iValue)
                    Else
                        GetCond = "unknown condition"
                    End If
                Case 12
                    Zone = FindVal(BL(2), BL(1), 0, 0, 2)
                    ThisX = FindVal(BL(6), BL(5), 0, 0, 2) / 100
                    ThisY = FindVal(BL(8), BL(7), 0, 0, 2) / 100
                    EventId = FindVal(BL(10), BL(9), 0, 0, 2)
                    GetCond = "Run quest trigger " + CStr(EventId) + " in zone " + CStr(Zone) + " Not fully coded yet!"
                Case 13
                    RefVar = CStr(FindVal(BL(2), BL(1), 0, 0, 2))
                    GetCond = "Set NPC number to " + RefVar
                Case 14
                    FlagId = FindVal(BL(2), BL(1), 0, 0, 2)
                    TrueFalse = FindVal(BL(3), 0, 0, 0, 1)
                    cond = "Undefined value = " + CStr(TrueFalse)
                    If TrueFalse = 0 Then cond = "IS NOT"
                    If TrueFalse = 1 Then cond = "IS"
                    GetCond = "Check quest flag " + CStr(FlagId) + " TRUE if flag " + cond + " present"
                Case 15
                    nNumber1 = FindVal(BL(2), BL(1), 0, 0, 2)
                    nNumber2 = FindVal(BL(4), BL(3), 0, 0, 2)
                GetCond = "Check number of party members. True if between " + CStr(nNumber1) + " and " + CStr(nNumber2)
                Case 16
                    btWho = FindVal(BL(1), 0, 0, 0, 1)
                    ulTime = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                    ulEndTime = FindVal(BL(12), BL(11), BL(10), BL(9), 4)
                    GetCond = "Check time in zone. uncoded"
                Case 17
                    GetCond = "Something to do with Objvar for two different NPCs. not coded"
                Case 18
                    ThisDate = FindVal(BL(1), 0, 0, 0, 1)
                    hour1 = FindVal(BL(2), 0, 0, 0, 1)
                    min1 = FindVal(BL(3), 0, 0, 0, 1)
                    hour2 = FindVal(BL(4), 0, 0, 0, 1)
                    min2 = FindVal(BL(5), 0, 0, 0, 1)
                    GetCond = "Check Sever time. TRUE if date = " + CStr(ThisDate) + " and time is between " + CStr(hour1) + ":" + CStr(min1) + " and " + CStr(hour2) + ":" + CStr(min2)
                Case 19
                    GetCond = "Time on day. Uncoded"
                Case 20
                    GetCond = "Unknown and uncoded"
                Case 21
                    GetCond = "Unknown and uncoded"
                Case 22
                    GetCond = "Unknown and uncoded"
                Case 23
                    btreg = FindVal(BL(1), 0, 0, 0, 1)
                    cond = "Undefined btreg value = " + CStr(btreg)
                    If btreg = 0 Then cond = "IS NOT"
                    If btreg = 1 Then cond = "IS"
                    GetCond = "TRUE if player " + cond + " in a clan"
                Case 24
                    npos = FindVal(BL(2), BL(1), 0, 0, 2)
                    btOp = FindVal(BL(3), 0, 0, 0, 1)
                    GetCond = "Check player's position in clan. TRUE if " + GetbtOp(btOp) + CStr(npos)
                Case 25
                    GetCond = "Clan donation. Not coded yet"
                Case 26
                    ngrd = FindVal(BL(2), BL(1), 0, 0, 2)
                    btOp = FindVal(BL(3), 0, 0, 0, 1)
                    GetCond = "Check player's clan grade. TRUE if " + GetbtOp(btOp) + CStr(ngrd)
                Case 27
                    nPoint = FindVal(BL(2), BL(1), 0, 0, 2)
                    btOp = FindVal(BL(3), 0, 0, 0, 1)
                    GetCond = "Check clan points for player's clan. TRUE if " + GetbtOp(btOp) + CStr(nPoint)
                Case 28
                    GetCond = "Check clan funds. Not coded"
                Case 29
                    GetCond = "Check clan members. Not coded"
                Case 30
                    GetCond = "Check clan skills. Not coded"
            End Select
    End Function
    Function GetAction(ByVal OpCode As Long, ByVal i As Integer, ByVal mode As Integer) As String
        Dim BL(200), rwdType, eqType, btWho, msgType As Byte
        Dim t, reps, sp, sval, shNameLen, nVarNo, flag, Hash As Integer
        Dim ThisSplit(200) As String
        Dim TempByteString As String
        Dim btOp, QuestId, ItemId, dupCnt, PartyOpt, dataCnt, iVarNo, iVarType, iValue, itemsn, percenthp, percentmp As Long
        Dim Zone, thisX, thisY, monId, iRange, iTeam, ltbVal, skillNo, stringId, arraysize As Long
        Dim Cond, rwd, tempName, ltbString As String

        If mode = 0 Then
            ListBox5.Items.Add(OpCode - 16777216)
            For t = 1 To 200 'copy the data into a more managable format
                BL(t) = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Bytes(t)
            Next t
        Else
            TempByteString = TextBox7.Text
            ThisSplit = Split(TempByteString, "  ", -1)
            arraysize = ThisSplit.GetUpperBound(0)
            If arraysize > 0 Then
                For t = 0 To arraysize 'copy the data into a more managable format
                    BL(t) = CByte(ThisSplit(t))
                Next t
            End If
        End If

        GetAction = "No definition available for opcode " + CStr(OpCode)
        Select Case OpCode
            Case 16777216 '0
                QuestId = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                btOp = FindVal(BL(5), 0, 0, 0, 1)
                Cond = ""
                If btOp = 0 Then Cond = "Remove Quest"
                If btOp = 1 Then Cond = "Start Quest"
                If btOp = 2 Then Cond = "Replace Quest but keep items"
                If btOp = 3 Then Cond = "Replace Quest and delete items"
                If btOp = 4 Then Cond = "Select"
                GetAction = "Update Quest " + CStr(QuestId) + ". " + Cond
            Case 16777217 '1
                ItemId = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                btOp = FindVal(BL(5), 0, 0, 0, 1)
                dupCnt = FindVal(BL(8), BL(7), 0, 0, 2)
                PartyOpt = FindVal(BL(9), 0, 0, 0, 1)
                Cond = ""
                If btOp = 0 Then Cond = " Subtract "
                If btOp = 1 Then Cond = " Add "
                GetAction = "Update quest items. " + Cond + CStr(dupCnt) + " items with id " + CStr(ItemId)
            Case 16777218 '2
                dataCnt = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                For reps = 0 To dataCnt
                    sp = reps * 8
                    iVarNo = FindVal(BL(6), BL(5), 0, 0, 2)
                    iVarType = FindVal(BL(8), BL(7), 0, 0, 2)
                    iValue = FindVal(BL(10), BL(9), 0, 0, 2)
                    btOp = FindVal(BL(11), 0, 0, 0, 1)
                    GetAction = GetAction + "Set Quest variable[" + GetVarType(iVarType) + "][" + CStr(iVarNo) + "]. " + GetbtOp(btOp) + CStr(iValue)
                Next
            Case 16777219 '3
                dataCnt = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                iVarType = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                iValue = FindVal(BL(12), BL(11), BL(10), BL(9), 4)
                btOp = FindVal(BL(13), 0, 0, 0, 1)
                GetAction = "Update stats." + GetSoption(iVarType) + GetbtOp(btOp) + CStr(iValue)
            Case 16777220 '4
                GetAction = "Set Quest variable"
                dataCnt = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                For reps = 0 To dataCnt
                    sp = reps * 8
                    iVarNo = FindVal(BL(6), BL(5), 0, 0, 2)
                    iVarType = FindVal(BL(8), BL(7), 0, 0, 2)
                    iValue = FindVal(BL(10), BL(9), 0, 0, 2)
                    btOp = FindVal(BL(11), 0, 0, 0, 1)
                    GetAction = GetAction + "Set Quest variable[" + GetVarType(iVarType) + "][" + CStr(iVarNo) + "]. " + GetbtOp(btOp) + CStr(iValue)
                Next
            Case 16777221 '5
                rwdType = FindVal(BL(1), 0, 0, 0, 1)
                eqType = FindVal(BL(2), 0, 0, 0, 1)
                sval = FindVal(BL(6), BL(5), 0, 0, 2)
                itemsn = FindVal(BL(12), BL(11), BL(10), BL(9), 4)
                rwd = ""
                If rwdType = 0 Then rwd = CStr(sval) + " exp "
                If rwdType = 1 Then rwd = CStr(sval) + " zuly "
                If rwdType = 2 Then rwd = CStr(sval) + " item(s) with id " + CStr(itemsn)
                GetAction = "Give quest reward. " + rwd
            Case 16777222 '6
                percenthp = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                percentmp = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                PartyOpt = FindVal(BL(9), 0, 0, 0, 1)
                GetAction = "Restore HP " + CStr(percenthp) + "%. Restore MP " + CStr(percentmp) + "%. Party Option = " + CStr(PartyOpt)
            Case 16777223 '7
                Zone = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                thisX = FindVal(BL(8), BL(7), BL(6), BL(5), 4) / 100
                thisY = FindVal(BL(12), BL(11), BL(10), BL(9), 4) / 100
                PartyOpt = FindVal(BL(13), 0, 0, 0, 1)
                GetAction = "Teleport to Map " + CStr(Zone) + ". X = " + CStr(thisX) + " Y = " + CStr(thisY) + " Party option = " + CStr(PartyOpt)
            Case 16777224 '8
                monId = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                dataCnt = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                btWho = FindVal(BL(9), 0, 0, 0, 1)
                Zone = FindVal(BL(14), BL(13), BL(12), BL(11), 4)
                thisX = FindVal(BL(18), BL(17), BL(16), BL(15), 4) / 100
                thisY = FindVal(BL(22), BL(21), BL(20), BL(19), 4) / 100
                iRange = FindVal(BL(26), BL(25), BL(24), BL(23), 4)
                iTeam = FindVal(BL(30), BL(29), BL(28), BL(27), 4)
                GetAction = "Spawn " + CStr(dataCnt) + GetMob(monId) + " within range " + CStr(iRange) + " of point " + CStr(thisX) + ", " + CStr(thisY) + " Map " + GetMap(Zone)
            Case 16777225 '9
                shNameLen = FindVal(BL(2), BL(1), 0, 0, 2)
                tempName = ""
                For t = 3 To shNameLen + 3
                    tempName = tempName + Chr(BL(t))
                Next t
                GetAction = "Execute Quest trigger " + tempName
            Case 16777226 '10
                GetAction = "Reset Stats"
            Case 16777227 '11
                btWho = FindVal(BL(1), 0, 0, 0, 1)
                nVarNo = FindVal(BL(4), BL(3), 0, 0, 2)
                iValue = FindVal(BL(8), BL(7), BL(6), BL(5), 4)
                btOp = FindVal(BL(9), 0, 0, 0, 1)
                GetAction = "Set ObjVar[" + CStr(RefVar) + "][" + CStr(nVarNo) + "] " + GetbtOp(btOp) + CStr(iValue)
            Case 16777228 '12
                msgType = FindVal(BL(1), 0, 0, 0, 1)
                ltbVal = FindVal(BL(6), BL(5), BL(4), BL(3), 4)
                If msgType = 0 Then GetAction = "Whisper '"
                If msgType = 1 Then GetAction = "Shout '"
                If msgType = 2 Then GetAction = "Announce '"
                ltbString = GetLTB(ltbVal)
                GetAction = GetAction + ltbString + "'"
            Case 16777229 '13
                shNameLen = FindVal(BL(2), BL(1), 0, 0, 2)
                tempName = ""
                For t = 3 To shNameLen + 3
                    tempName = tempName + Chr(BL(t))
                Next t
                GetAction = "Execute Quest trigger " + tempName + ". This function not coded yet"
            Case 16777230 '14
                btOp = FindVal(BL(1), 0, 0, 0, 1)
                skillNo = FindVal(BL(6), BL(5), BL(4), BL(3), 4)
                GetAction = "Learn skill " + CStr(skillNo) + " btOp = " + CStr(btOp)
            Case 16777231 '15
                flag = FindVal(BL(2), BL(1), 0, 0, 2)
                btOp = FindVal(BL(3), 0, 0, 0, 1)
                Cond = ""
                If btOp = 0 Then Cond = "FALSE"
                If btOp = 1 Then Cond = "TRUE"
                GetAction = "set quest flag [" + CStr(flag) + "] " + Cond
            Case 16777232 '16
                GetAction = "Unknown and Not yet coded"
            Case 16777233 '17
                GetAction = "Reset ALL Quest flags"
            Case 16777234 '18
                stringId = FindVal(BL(4), BL(3), BL(2), BL(1), 4)
                shNameLen = FindVal(BL(6), BL(5), 0, 0, 2)
                tempName = ""
                For t = 7 To shNameLen + 7
                    tempName = tempName + Chr(BL(t))
                Next t
                GetAction = "Send announcement '" + tempName + "'"
            Case 16777235 '19
                Zone = FindVal(BL(2), BL(1), 0, 0, 2)
                iTeam = FindVal(BL(4), BL(3), 0, 0, 2)
                shNameLen = FindVal(BL(6), BL(5), 0, 0, 2)
                tempName = ""
                For t = 7 To 24
                    tempName = tempName + Chr(BL(t))
                Next t
                Hash = FindVal(BL(26), BL(25), 0, 0, 2)
                GetAction = "Execute Quest trigger " + tempName + " for map " + CStr(Zone) + ". Hash = " + CStr(Hash) + " Mystery number = " + CStr(shNameLen)
            Case 16777236 '20
                btOp = FindVal(BL(1), 0, 0, 0, 1)
                If btOp = 0 Then GetAction = "Set PVP flag to FALSE"
                If btOp = 1 Then GetAction = "Set PVP flag to TRUE"
            Case 16777237 '21
                GetAction = "Set respawn coordinates. NOT yet coded"
            Case 16777238 '22
                GetAction = "Unknown and NOT coded"
            Case 16777239 '23
                GetAction = "Raise clan grade"
            Case 16777240 '24
                GetAction = "Clan funds. NOT yet coded"
            Case 16777241 '25
                GetAction = "Clan points. NOT yet coded"
            Case 16777242 '26
                skillNo = FindVal(BL(2), BL(1), 0, 0, 2)
                btOp = FindVal(BL(3), 0, 0, 0, 1)
                GetAction = "Clan skill " + CStr(skillNo) + "  btOp = " + CStr(btOp)
            Case 16777243 '27
                GetAction = "Clan contribution"
            Case 16777244 '28
                GetAction = "Clan teleport"
            Case 16777245 '29
                shNameLen = FindVal(BL(2), BL(1), 0, 0, 2)
                tempName = ""
                For t = 3 To shNameLen + 3
                    tempName = tempName + Chr(BL(t))
                Next t
                GetAction = "Execute Quest trigger " + tempName


        End Select
    End Function
    Private Sub ListBox4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox4.SelectedIndexChanged
        Dim t As Integer
        Dim TempByteString As String
        CondIndex = ListBox4.SelectedIndex + 1
        OpMode = 1
        DispCondData()
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox8.Text = Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command
        TempByteString = Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(0)
        For t = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length - 8
            TempByteString += "  " + CStr(Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t))
        Next t
        TextBox6.Text = TempByteString
    End Sub
    Private Sub ListBox6_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox6.SelectedIndexChanged
        Dim t As Integer
        Dim TempByteString As String
        ActionIndex = ListBox6.SelectedIndex + 1
        TextBox4.Text = ""
        TextBox5.Text = ""
        TextBox9.Text = Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command
        TempByteString = Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(0)
        For t = 1 To Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length - 8
            TempByteString += "  " + CStr(Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t))
        Next t
        TextBox7.Text = TempByteString
    End Sub
    Function FindVal(ByVal a As Byte, ByVal b As Byte, ByVal c As Byte, ByVal d As Byte, ByVal e As Byte) As Long
        Dim hexi As String
        Dim hexi1 As String
        Dim hexi2 As String
        Dim hexi3 As String
        Dim hexi4 As String
        Select Case e
            Case 1
                FindVal = CLng(a)
                'Case 2
                '    hexi = "&H" + CStr(Hex(a)) + CStr(Hex(b))
                '    FindVal = Val(hexi)
                'Case 4
                '    hexi = "&H" + CStr(Hex(a)) + CStr(Hex(b)) + CStr(Hex(c)) + CStr(Hex(d))
                '    FindVal = Val(hexi)
            Case 2
                hexi1 = CStr(Hex(a))
                If Len(hexi1) = 1 Then hexi1 = "0" + hexi1
                hexi2 = CStr(Hex(b))
                If Len(hexi2) = 1 Then hexi2 = "0" + hexi2
                hexi = "&H" + hexi1 + hexi2
                FindVal = Val(hexi)
            Case 4
                hexi1 = CStr(Hex(a))
                If Len(hexi1) = 1 Then hexi1 = "0" + hexi1
                hexi2 = CStr(Hex(b))
                If Len(hexi2) = 1 Then hexi2 = "0" + hexi2
                hexi3 = CStr(Hex(c))
                If Len(hexi3) = 1 Then hexi3 = "0" + hexi3
                hexi4 = CStr(Hex(d))
                If Len(hexi4) = 1 Then hexi4 = "0" + hexi4
                hexi = "&H" + hexi1 + hexi2 + hexi3 + hexi4
                FindVal = Val(hexi)
                a = a
        End Select
        a = a
    End Function
    Function GetbtOp(ByVal btOp) As String
        GetbtOp = ""
        Select Case btOp
            Case 0
                GetbtOp = " = "
            Case 1
                GetbtOp = " > "
            Case 2
                GetbtOp = " >= "
            Case 3
                GetbtOp = " < "
            Case 4
                GetbtOp = " <= "
            Case 5
                GetbtOp = " Set value to "
            Case 6
                GetbtOp = " Add value "
            Case 7
                GetbtOp = " Subtract value "
            Case 9
                GetbtOp = " Increment "
            Case 10
                GetbtOp = " != "
        End Select
    End Function
    Function GetABoption(ByVal ref) As String
        GetABoption = " Un-Defined "
        Select Case ref
            Case 0
                GetABoption = " Level "
            Case 1
                GetABoption = " Attack Power "
            Case 2
                GetABoption = " Defense "
            Case 3
                GetABoption = " Magic Defense "
            Case 4
                GetABoption = " HP "
            Case 5
                GetABoption = " Charm "
        End Select
    End Function
    Function GetSoption(ByVal ref) As String
        GetSoption = " Un-Defined "
        Select Case ref
            Case 2
                GetSoption = " Gender "
            Case 3
                GetSoption = " Birthstone "
            Case 4
                GetSoption = " Job "
            Case 5
                GetSoption = " Union "
            Case 6
                GetSoption = " Ranking "
            Case 7
                GetSoption = " Reputation "
            Case 10
                GetSoption = " Strength "
            Case 11
                GetSoption = " Dexterity "
            Case 12
                GetSoption = " Inteligence "
            Case 13
                GetSoption = " Concentration "
            Case 14
                GetSoption = " Charm "
            Case 15
                GetSoption = " Sense "
            Case 31
                GetSoption = " Level "
            Case 32
                GetSoption = " Stat points "
            Case 40
                GetSoption = " Money "
            Case 81
                GetSoption = " Junon order Union points "
            Case 82
                GetSoption = " Union 2 points "
            Case 83
                GetSoption = " Righteous Crusaders Union points "
            Case 84
                GetSoption = " Union 4 points "
            Case 85
                GetSoption = " Ferrel Guild Union points "
            Case 86
                GetSoption = " Union 6 points "
            Case 87
                GetSoption = " Union 7 points "
            Case 88
                GetSoption = " Union 8 points "
            Case 89
                GetSoption = " Union 9 points "
            Case 90
                GetSoption = " Kuro-Tejina Union points "
        End Select
    End Function
    Function GetVarType(ByVal nVarType As Integer) As String
        GetVarType = "undefined" + CStr(nVarType)
        Select Case nVarType
            Case 0
                GetVarType = "ActiveQuest"
            Case 16
                GetVarType = "SwitchBit"
            Case 32
                GetVarType = "Remaining Time"
            Case 48
                GetVarType = "EpisodeVar"
            Case 64
                GetVarType = "JobVar"
            Case 80
                GetVarType = "PlanetVar"
            Case 96
                GetVarType = "UnionVar"
        End Select
    End Function
    Function GetMap(ByVal zone As Integer) As String
        GetMap = CStr(zone)

    End Function
    Function GetMob(ByVal monid As Integer) As String
        GetMob = CStr(monid)
    End Function
    Function GetLTB(ByVal ltbVal As Long) As String
        GetLTB = CStr(ltbVal)
    End Function
    
    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim thisentry As String
        Dim OpCode As Long
        If TextBox8.Text = "" Then Exit Sub
        thisentry = GetCond(CLng(TextBox8.Text), 1, 1)
        TextBox3.Text = thisentry
        OpCode = TextBox8.Text
        TextBox2.Text = OpCode
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        'put the current condition data into the record structure
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim CondString, TempByteString, ThisSplit(200) As String
        CondString = ""
        a = a
        If TextBox8.Text = "" Then Exit Sub
        'Set data block size
        a = a
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = CLng(TextBox8.Text)
        TempByteString = TextBox6.Text
        ThisSplit = Split(TempByteString, "  ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length = arraysize + 8
        For t = 0 To 200
            Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
        Next
        For t = 0 To arraysize 'copy the data into a more managable format
            Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = CByte(ThisSplit(t))
        Next t
        OpCode = CLng(TextBox8.Text)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = OpCode
        'clear outputs
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            'ListBox3.Items.Add(OpCode)
            ListBox4.Items.Add(GetCond(OpCode, i, 0))
        Next i
        'ListBox4.SelectedIndex = CondIndex - 1
    End Sub
    
    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        'Add the current condition data into the record structure as a new condition
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim CondString, TempByteString, ThisSplit(200) As String
        CondString = ""
        a = a
        If TextBox8.Text = "" Then Exit Sub
        'Set data block size
        a = a

        'add one more record to the index
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = Blocks(BlockIndex).Records(RecordIndex).Conditioncount + 1
        CondIndex = Blocks(BlockIndex).Records(RecordIndex).Conditioncount
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = CLng(TextBox8.Text)
        TempByteString = TextBox6.Text
        ThisSplit = Split(TempByteString, "  ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length = arraysize + 8 + 1
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes = New Byte(200) {}
        a = a
        For t = 0 To 200
            Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
        Next
        If arraysize > 0 Then
            For t = 0 To arraysize 'copy the data into a more managable format
                Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = CByte(ThisSplit(t))
            Next t
        End If
        OpCode = CLng(TextBox8.Text)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = OpCode
        a = a
        'clear outputs
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            ListBox4.Items.Add(GetCond(OpCode, i, 0))
        Next i
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        'delete condition
        Dim OpCode As Long
        Dim rusure, i, t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected condition?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = CondIndex To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            Blocks(BlockIndex).Records(RecordIndex).Conditions(t) = Blocks(BlockIndex).Records(RecordIndex).Conditions(t + 1)
        Next t
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = Blocks(BlockIndex).Records(RecordIndex).Conditioncount - 1
        'clear outputs
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            'ListBox3.Items.Add(OpCode)
            ListBox4.Items.Add(GetCond(OpCode, i, 0))
        Next i
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        Dim thisentry As String
        Dim OpCode As Long
        If TextBox9.Text = "" Then Exit Sub
        thisentry = GetAction(CLng(TextBox9.Text), 1, 1)
        TextBox5.Text = thisentry
        OpCode = TextBox9.Text
        TextBox4.Text = OpCode - 16777216
    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        'put the current action data into the record structure
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim ActionString, TempByteString, ThisSplit(200) As String
        ActionString = ""
        a = a
        If TextBox9.Text = "" Then Exit Sub
        'Set data block size
        a = a
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = CLng(TextBox9.Text)
        TempByteString = TextBox7.Text
        ThisSplit = Split(TempByteString, "  ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length = arraysize + 8
        For t = 0 To 200
            Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = 0
        Next
        For t = 0 To arraysize 'copy the data into a more managable format
            Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = CByte(ThisSplit(t))
        Next t
        OpCode = CLng(TextBox9.Text)
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = OpCode
        'clear outputs
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            'ListBox5.Items.Add(OpCode)
            ListBox6.Items.Add(GetAction(OpCode, i, 0))
        Next i
        'ListBox4.SelectedIndex = CondIndex - 1
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        'Add the current action data into the record structure as a new condition
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim ActionString, TempByteString, ThisSplit(200) As String
        actionString = ""
        a = a
        If TextBox9.Text = "" Then Exit Sub
        'Set data block size
        a = a

        'add one more record to the index
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = Blocks(BlockIndex).Records(RecordIndex).Actioncount + 1
        ActionIndex = Blocks(BlockIndex).Records(RecordIndex).Actioncount
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = CLng(TextBox9.Text)
        TempByteString = TextBox7.Text
        ThisSplit = Split(TempByteString, "  ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length = arraysize + 8 + 1 'arraysize is 1 smaller than the actual size of the array ????
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes = New Byte(200) {}
        For t = 0 To 200
            Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = 0
        Next
        If arraysize > 0 Then
            For t = 0 To arraysize 'copy the data into a more managable format
                Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = CByte(ThisSplit(t))
            Next t
        End If
        OpCode = CLng(TextBox9.Text)
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = OpCode
        a = a
        'clear outputs
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ListBox6.Items.Add(GetAction(OpCode, i, 0))
            a = a
        Next i
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        'Delete Action
        Dim OpCode As Long
        Dim rusure, i, t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected condition?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = ActionIndex To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            Blocks(BlockIndex).Records(RecordIndex).Actions(t) = Blocks(BlockIndex).Records(RecordIndex).Actions(t + 1)
        Next t
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = Blocks(BlockIndex).Records(RecordIndex).Actioncount - 1
        'clear outputs
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            'ListBox5.Items.Add(OpCode)
            ListBox6.Items.Add(GetAction(OpCode, i, 0))
        Next i
    End Sub

    Private Sub TextBox8_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox8.MouseClick
        OpMode = 1
        Opcodes.Show()
    End Sub

    Private Sub TextBox9_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox9.MouseClick
        Dim a As Integer
        OpMode = 2
        a = a
        Opcodes.Show()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'add a new record
        Dim n As Integer
        If BlockIndex = 0 Then
            MsgBox("Please select a Block to add the record to")
        End If
        Blocks(BlockIndex).RecordCount = Blocks(BlockIndex).RecordCount + 1
        RecordIndex = Blocks(BlockIndex).RecordCount
        Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes = New Byte(30) {}
        Blocks(BlockIndex).Records(RecordIndex).Conditions = New condition(50) {}
        Blocks(BlockIndex).Records(RecordIndex).Actions = New action(50) {}
        For n = 0 To 30
            Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes(n) = 0
        Next n
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = 0
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = 0
        Dim i As Integer
        ListBox2.Items.Clear()
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        TextBox10.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim TempRecord As Record
        Dim opCode, i As Integer
        If RecordIndex = 1 Then
            MsgBox("Cannot move up. This is the first record")
            Exit Sub
        End If
        TempRecord = Blocks(BlockIndex).Records(RecordIndex - 1)
        Blocks(BlockIndex).Records(RecordIndex - 1) = Blocks(BlockIndex).Records(RecordIndex)
        Blocks(BlockIndex).Records(RecordIndex) = TempRecord
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        RefVar = "undefined"

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            ListBox4.Items.Add(GetCond(OpCode, i, 0))
        Next i

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ListBox6.Items.Add(GetAction(OpCode, i, 0))
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim TempRecord As Record
        Dim opCode, i As Integer

        If RecordIndex = Blocks(BlockIndex).RecordCount Then
            MsgBox("Cannot move down. This is the last record")
            Exit Sub
        End If
        TempRecord = Blocks(BlockIndex).Records(RecordIndex + 1)
        Blocks(BlockIndex).Records(RecordIndex + 1) = Blocks(BlockIndex).Records(RecordIndex)
        Blocks(BlockIndex).Records(RecordIndex) = TempRecord
        
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        RefVar = "undefined"

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            opCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            ListBox4.Items.Add(GetCond(opCode, i, 0))
        Next i

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            opCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ListBox6.Items.Add(GetAction(opCode, i, 0))
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim RUsure As String
        Dim t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected record?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = RecordIndex To Blocks(BlockIndex).RecordCount - 1
            Blocks(BlockIndex).Records(t) = Blocks(BlockIndex).Records(t + 1)
        Next t
        Blocks(BlockIndex).RecordCount = Blocks(BlockIndex).RecordCount - 1
        Dim i As Integer
        ListBox2.Items.Clear()
        ListBox3.Items.Clear()
        ListBox4.Items.Clear()
        ListBox5.Items.Clear()
        ListBox6.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        TextBox10.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub

    
    Private Sub TextBox9_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox9.TextChanged

    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Dim NewName As String
        Dim i, j As Integer
        Dim CanUseName As Boolean
        CanUseName = True
        NewName = TextBox11.Text
        For i = 1 To BlockCount
            For j = 1 To Blocks(i).RecordCount
                If Blocks(i).Records(j).Recordname = NewName Then
                    CanUseName = False
                End If
            Next
        Next
        If CanUseName = False Then
            MsgBox("Sorry. That name is already in use. please pick another")
            Exit Sub
        End If
        Blocks(BlockIndex).Records(RecordIndex).Recordname = NewName
        For i = 1 To Len(NewName)
            Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes(i) = CByte(Asc(Mid(NewName, i, 1)))
        Next
        ListBox2.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            Blocks(BlockIndex).Records(RecordIndex).If_Else = 1
        Else
            Blocks(BlockIndex).Records(RecordIndex).If_Else = 0
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        condlist.Items.Add("0  : Check Quest.")
        condlist.Items.Add("1  : Check Quest Variable.")
        condlist.Items.Add("2  : Check Quest variable.")
        condlist.Items.Add("3  : Check Stats.")
        condlist.Items.Add("4  : Check items.")
        condlist.Items.Add("5  : Check Party.")
        condlist.Items.Add("6  : Check position.")
        condlist.Items.Add("7  : Check World Time.")
        condlist.Items.Add("8  : Check Quest Timer.")
        condlist.Items.Add("9  : Check Skills.")
        condlist.Items.Add("10 : Comparrison. Is something (random number?) between A and B ")
        condlist.Items.Add("11 : Check ObjVar.")
        condlist.Items.Add("12 : Check Proximity and quest trigger hash in zone(not coded yet)")
        condlist.Items.Add("13 : Select NPC.")
        condlist.Items.Add("14 : Check Quest Flag.")
        condlist.Items.Add("15 : Unknown. Some sort of party check perhaps")
        condlist.Items.Add("16 : Check Zone time.")
        condlist.Items.Add("17 : Compare ObjVar values for two NPCs.")
        condlist.Items.Add("18 : Check Server time and date.")
        condlist.Items.Add("19 : Check Server time and weekday.")
        condlist.Items.Add("20 : Unknown. Appears to be comparing two values")
        condlist.Items.Add("21 : Unknown. Include object type and radius")
        condlist.Items.Add("22 : Unknown. includes X and Y coordinates.")
        condlist.Items.Add("23 : Check Clan.")
        condlist.Items.Add("24 : Check my position in clan.")
        condlist.Items.Add("25 : Check my clan contribution.")
        condlist.Items.Add("26 : Check my clan grade.")
        condlist.Items.Add("27 : Check my clan points.")
        condlist.Items.Add("28 : Check my clan funds.")
        condlist.Items.Add("29 : Check my clan members.")
        condlist.Items.Add("30 : Check my clan skills.")

        actionlist.Items.Add("0 : Update Quest")
        actionlist.Items.Add("1 : Update Quest items")
        actionlist.Items.Add("2 : Set Quest variable")
        actionlist.Items.Add("3 : Update Stats")
        actionlist.Items.Add("4 : Set Quest variable")
        actionlist.Items.Add("5 : Give Quest reward")
        actionlist.Items.Add("6 : Restore HP/MP")
        actionlist.Items.Add("7 : Teleport to specified zone and coordinates")
        actionlist.Items.Add("8 : Spawn Monster(s)")
        actionlist.Items.Add("9 : Execute Quest trigger")
        actionlist.Items.Add("10 : Reset Stats")
        actionlist.Items.Add("11 : Set/Update ObjVar")
        actionlist.Items.Add("12 : NPC Speak/shout/Announce")
        actionlist.Items.Add("13 : Execute Quest Trigger (I think. not completely sure at this point)")
        actionlist.Items.Add("14 : learn Skill.")
        actionlist.Items.Add("15 : Set Quest flag.")
        actionlist.Items.Add("16 : Unknown. Something about groups??")
        actionlist.Items.Add("17 : Reset ALL Quest flags")
        actionlist.Items.Add("18 : Send Announcement")
        actionlist.Items.Add("19 : Execute Quest Trigger in another map.")
        actionlist.Items.Add("20 : Set PVP status")
        actionlist.Items.Add("21 : Set respawn position")
        actionlist.Items.Add("22 : Unknown. (zone and btOp)")
        actionlist.Items.Add("23 : Raise Clan Grade")
        actionlist.Items.Add("24 : Adjust Clan funds.")
        actionlist.Items.Add("25 : Adjust Clan points.")
        actionlist.Items.Add("26 : Adjust Clan Skills.")
        actionlist.Items.Add("27 : Adjust Clan Contributions.")
        actionlist.Items.Add("28 : Clan teleport")
        actionlist.Items.Add("29 : Unknown")
        actionlist.Items.Add("30 : Reset Skills")
    End Sub

    Private Sub condlist_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condlist.SelectedIndexChanged
        OpMode = 0
        DispCondData()
    End Sub

    Private Sub TextBox8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox8.TextChanged

    End Sub
    Private Sub DispCondData()
        Dim t As Integer
        Dim QuestID, DataCnt, ThisItem, Slot, iValue, ThisType, iType, iVarNo, iVartype, flagid As Integer
        Dim ThisRefVar, nVarno As Integer
        Dim btOp, btwho, Lowpoint, Highpoint As Byte
        Dim cond As String
        'clear all the labels. make them invisible
        condlabel1.Visible = False  '1
        condlabel2.Visible = False  '2
        condlabel3.Visible = False  '3
        datalabel1.Visible = False  '11
        datalabel2.Visible = False  '12
        datalabel3.Visible = False  '13
        condTF1.Visible = False     '21
        condcombo1.Visible = False  '31
        CondCombo2.Visible = False  '32
        CondCombo3.Items.Clear()
        CondCombo3.Visible = False  '33
        condoption1.Visible = False  '41
        For t = 1 To 500
            TBL(t) = 0
        Next
        If OpMode = 1 Then
            ThisCondOpCode = ThisRecord.Conditions(CondIndex).Command
            For t = 1 To ThisRecord.Conditions(CondIndex).Length - 8
                TBL(t) = ThisRecord.Conditions(CondIndex).Bytes(t)
            Next t
        Else
            ThisCondOpCode = condlist.SelectedIndex
        End If

        t = t
        Select Case ThisCondOpCode
            Case 0
                'Check Quest
                condlabel1.Text = "Opcode 0: Check Quest:"
                'condtext1.Top = 15
                'datalabel1.Width = 40
                If OpMode = 1 Then
                    QuestID = FindVal(TBL(4), TBL(3), TBL(2), TBL(1), 4)
                    datalabel1.Text = QuestID
                End If
                condlabel2.Text = "TRUE if Quest is present"
                SetCondFormat(1, 11, 2, 0, 0, 0, 0, 0)
            Case 1
                condlabel1.Text = "Opcode 1: Check Quest Variable: Data Count"
                If OpMode = 1 Then
                    DataCnt = FindVal(TBL(2), TBL(1), 0, 0, 2)
                    iType = FindVal(TBL(4), TBL(3), 0, 0, 2)
                    iVarNo = FindVal(TBL(6), TBL(5), 0, 0, 2)
                    iVartype = FindVal(TBL(8), TBL(7), 0, 0, 2)
                    iValue = FindVal(TBL(10), TBL(9), 0, 0, 2)
                    btOp = FindVal(TBL(11), 0, 0, 0, 1)
                    datalabel1.Text = DataCnt
                End If
                SetCondFormat(1, 11, 0, 0, 0, 0, 0, 0)
            Case 3
                condlabel1.Text = "Opcode 3: Check Stats: Data Count"
                datalabel1.Text = 1
                condlabel2.Text = "TRUE if"
                condcombo1.Text = "Level"
                condoption1.Text = " = "
                datalabel2.Text = "0"
                If OpMode = 1 Then
                    DataCnt = FindVal(TBL(4), TBL(3), TBL(2), TBL(1), 4)
                    ThisType = FindVal(TBL(8), TBL(7), TBL(6), TBL(5), 4)
                    iValue = FindVal(TBL(12), TBL(11), TBL(10), TBL(9), 4)
                    btOp = FindVal(TBL(13), 0, 0, 0, 1)
                    cond = GetbtOp(btOp)
                    datalabel1.Text = DataCnt
                    condcombo1.Text = GetSoption(ThisType)
                    condoption1.Text = cond
                    datalabel2.Text = iValue
                End If
                SetCondFormat(1, 11, 2, 31, 41, 12, 0, 0)
            Case 4
                condlabel1.Text = "Opcode 4: Check Items: Data Count"
                datalabel1.Text = "1"
                condlabel2.Text = "Search inventory for items type:"
                datalabel2.Text = "13001"
                condlabel3.Text = "TRUE if"
                condoption1.Text = " = "
                datalabel3.Text = "0"
                If OpMode = 1 Then
                    DataCnt = FindVal(TBL(4), TBL(3), TBL(2), TBL(1), 4)
                    ThisItem = FindVal(TBL(8), TBL(7), TBL(6), TBL(5), 4)
                    Slot = FindVal(TBL(12), TBL(11), TBL(10), TBL(9), 4)
                    iValue = FindVal(TBL(16), TBL(15), TBL(14), TBL(13), 4)
                    btOp = FindVal(TBL(17), 0, 0, 0, 1)
                    datalabel1.Text = DataCnt
                    datalabel2.Text = ThisItem
                    cond = GetbtOp(btOp)
                    condoption1.Text = cond
                    datalabel3.Text = iValue
                End If
                SetCondFormat(1, 11, 2, 12, 3, 41, 13, 0)
            Case 10
                condlabel1.Text = "Opcode 10: Random number (0 to 100): Minimum:"
                datalabel1.Text = "0"
                condlabel2.Text = "Maximum:"
                datalabel2.Text = "50"
                If OpMode = 1 Then
                    lowPoint = FindVal(TBL(1), 0, 0, 0, 1)
                    Highpoint = FindVal(TBL(2), 0, 0, 0, 1)
                    datalabel1.Text = Lowpoint
                    datalabel2.Text = Highpoint
                End If
                SetCondFormat(1, 11, 2, 12, 0, 0, 0, 0)
            Case 11
                condlabel1.Text = "Opcode 11: Check Object Variable "
                datalabel1.Text = "0"
                condlabel2.Text = "for selected NPC. TRUE if value"
                condoption1.Text = " = "
                datalabel3.Text = "0"
                If OpMode = 1 Then
                    btWho = FindVal(TBL(1), 0, 0, 0, 1)
                    nVarno = FindVal(TBL(4), TBL(3), 0, 0, 2)
                    iValue = FindVal(TBL(6), TBL(5), 0, 0, 2)
                    btOp = FindVal(TBL(7), 0, 0, 0, 1)
                    datalabel1.Text = nVarno
                    cond = GetbtOp(btOp)
                    condoption1.Text = cond
                    datalabel2.Text = iValue
                End If
                SetCondFormat(1, 11, 2, 41, 12, 0, 0, 0)
            Case 13
                condlabel1.Text = "Opcode 13: Select NPC Ref Variable:"
                datalabel1.Text = "1000"
                If OpMode = 1 Then
                    ThisRefVar = CStr(FindVal(TBL(2), TBL(1), 0, 0, 2))
                    datalabel1.Text = ThisRefVar
                End If
                SetCondFormat(1, 11, 0, 0, 0, 0, 0, 0)
            Case 14
                condlabel1.Text = "Opcode 14: Check Quest Flag: TRUE if flag"
                datalabel1.Text = "0"
                condTF1.Text = "IS"
                condlabel2.Text = "set"
                If OpMode = 1 Then
                    flagid = FindVal(TBL(2), TBL(1), 0, 0, 2)
                    btOp = FindVal(TBL(3), 0, 0, 0, 1)
                    datalabel1.Text = flagid
                    If btOp = 1 Then
                        condTF1.Text = "IS"
                    Else
                        condTF1.Text = "IS NOT"
                    End If
                End If
                SetCondFormat(1, 11, 21, 2, 0, 0, 0, 0)
        End Select
        t = t
    End Sub

    Private Sub datalabel1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles datalabel1.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", datalabel1.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            datalabel1.Text = newval
            FormatCond()
        End If
bypass:
    End Sub

    Private Sub datalabel2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles datalabel2.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", datalabel2.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            datalabel2.Text = newval
            FormatCond()
        End If
bypass:
    End Sub
    Private Sub datalabel3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles datalabel3.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", datalabel3.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            datalabel3.Text = newval
            FormatCond()
        End If
bypass:
    End Sub
    Sub FormatCond()
        Dim t, lastcond, thiscond, leftpos As Integer
        condlabel1.Visible = True
        For t = 2 To 8
            thiscond = CondFormat(t)
            If thiscond <> 0 Then
                lastcond = CondFormat(t - 1)
                Select Case lastcond
                    Case 1
                        leftpos = condlabel1.Left + condlabel1.Width + 5
                    Case 2
                        leftpos = condlabel2.Left + condlabel2.Width + 5
                    Case 3
                        leftpos = condlabel3.Left + condlabel3.Width + 5
                    Case 11
                        leftpos = datalabel1.Left + datalabel1.Width + 5
                    Case 12
                        leftpos = datalabel2.Left + datalabel2.Width + 5
                    Case 13
                        leftpos = datalabel3.Left + datalabel3.Width + 5
                    Case 21
                        leftpos = condTF1.Left + condTF1.Width + 5
                    Case 31
                        leftpos = condcombo1.Left + condcombo1.Width + 5
                    Case 32
                        leftpos = CondCombo2.Left + CondCombo2.Width + 5
                    Case 41
                        leftpos = condoption1.Left + condoption1.Width + 5
                End Select
                Select Case thiscond
                    Case 2
                        condlabel2.Left = leftpos
                        condlabel2.Visible = True
                    Case 3
                        condlabel3.Left = leftpos
                        condlabel3.Visible = True
                    Case 4
                        condlabel4.Left = leftpos
                        condlabel4.Visible = True
                    Case 11
                        datalabel1.Left = leftpos
                        datalabel1.Visible = True
                    Case 12
                        datalabel2.Left = leftpos
                        datalabel2.Visible = True
                    Case 13
                        datalabel3.Left = leftpos
                        datalabel3.Visible = True
                    Case 14
                        datalabel3.Left = leftpos
                        datalabel3.Visible = True
                    Case 21
                        condTF1.Left = leftpos
                        condTF1.Visible = True
                    Case 22
                        'condTF2.left = leftpos
                    Case 31
                        condcombo1.Left = leftpos
                        condcombo1.Visible = True
                    Case 32
                        CondCombo2.Left = leftpos
                        CondCombo2.Visible = True
                    Case 41
                        condoption1.Left = leftpos
                        condoption1.Visible = True
                End Select
            End If
        Next
    End Sub
    Private Sub SetCondFormat(ByVal a As Integer, ByVal b As Integer, ByVal c As Integer, ByVal d As Integer, ByVal e As Integer, ByVal f As Integer, ByVal g As Integer, ByVal h As Integer)
        CondFormat(1) = a
        CondFormat(2) = b
        CondFormat(3) = c
        CondFormat(4) = d
        CondFormat(5) = e
        CondFormat(6) = f
        CondFormat(7) = g
        CondFormat(8) = h
        FormatCond()
    End Sub
    Private Sub ClearCondFormat()
        Dim t As Integer
        For t = 1 To 8
            CondFormat(t) = 0
        Next
    End Sub
    Private Sub LoadCondCombo1()
        Dim t As Integer
        condedit.ComboBox1.Items.Clear()
        For t = 1 To 100
            condedit.ComboBox1.Items.Add(GetSoption(t))
        Next
    End Sub
    Private Sub LoadCondCombo2()
        Dim t As Integer
        CondCombo2.Items.Clear()
        For t = 1 To 11
            CondCombo2.Items.Add(GetbtOp(t - 1))
            t = t
        Next
    End Sub

    Private Sub condTF1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condTF1.Click
        If condTF1.Text = "IS" Then
            condTF1.Text = "IS NOT"
        Else
            condTF1.Text = "IS"
        End If
        FormatCond()
    End Sub

    Private Sub condoption1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condoption1.Click
        Dim a As String
        a = condoption1.Text
        Select Case a
            Case " != "
                condoption1.Text = " = "
            Case " = "
                condoption1.Text = " > "
            Case " > "
                condoption1.Text = " >= "
            Case " >= "
                condoption1.Text = " < "
            Case " < "
                condoption1.Text = " <= "
            Case " <= "
                condoption1.Text = " Set value to "
            Case " Set value to "
                condoption1.Text = " Add value "
            Case " Add value "
                condoption1.Text = " Subtract value "
            Case " Subtract value "
                condoption1.Text = " Increment "
            Case " Increment "
                condoption1.Text = " != "
        End Select
        FormatCond()
    End Sub


    Private Sub condcombo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condcombo1.Click
        LoadCondCombo1()
        condedit.ComboBox1.Visible = True
        condedit.Show()
        FormatCond()
    End Sub

   
End Class
